package fi.helsinki.cs.seco.onki.config;

import java.util.List;

import com.hp.hpl.jena.rdf.model.RDFList;
import com.hp.hpl.jena.rdf.model.RDFNode;

public class LogConfiguration extends DataSourceConfiguration {

	public String getErrorFile() {
		return this.getFilePath("errorFile", true);
	}
	
	private RDFList getLogLevel() {
		return (RDFList)this.getProperty("loglevel").as(RDFList.class);
	}
	
	public boolean getLogLevelError() {
		return this.getLogLevel().contains(this.onkiConfig.getOnkiConfResource("error"));
	}
	
	public boolean getLogLevelWarning() {
		return this.getLogLevel().contains(this.onkiConfig.getOnkiConfResource("warning"));
	}

	public boolean getLogLevelInfo() {
		return this.getLogLevel().contains(this.onkiConfig.getOnkiConfResource("info"));
	}
	
	public boolean getLogLevelDebug() {
		return this.getLogLevel().contains(this.onkiConfig.getOnkiConfResource("debug"));
	}
	
}
