package fi.helsinki.cs.seco.onki.config;

import java.util.List;

import com.hp.hpl.jena.rdf.model.Resource;

public class OnkiServerConfiguration extends ServiceConfiguration {

	public String getHomeDir() {
		return this.addSlashToDir(this.getPropertyAsString("homedir"));
	}
	
	public DataSourceConfiguration getDataSource() {
		return this.onkiConfig.createDataSourceConfiguration(this.getPropertyAsResource("dataSource"), this);
	}
	
	public LogConfiguration getLogConfiguration() {
		return this.onkiConfig.createLogConfiguration(this.getPropertyAsResource("log"), this);
	}
	
	public TemplateConfiguration getTemplateConfiguration() {
		return this.onkiConfig.createTemplateConfiguration(this.getPropertyAsResource("template"), this);
	}
	
	public ConfigConfiguration getConfigConfiguration() {
		return this.onkiConfig.createConfigConfiguration(this.getPropertyAsResource("configSource"), this);
	}
	
	protected DataSourceConfiguration getDataSource(String id) {
		if (id == "dataSource")
			return this.getDataSource();
		if (id == "log")
			return (DataSourceConfiguration)this.getLogConfiguration();
		if (id == "template")
			return (DataSourceConfiguration)this.getTemplateConfiguration();
		if (id == "configSource")
			return (DataSourceConfiguration)this.getConfigConfiguration();
		
		return null;
	}
}
