package fi.helsinki.cs.seco.onki.logic;

import java.util.List;

import com.hp.hpl.jena.rdf.model.Statement;

/**
 * For generating simple OnkiStatements from complex RDF structures. 
 */

public interface IPropertyFiddler {

    /**
	 * Generate statements starting from RDF statements where the current resource is
	 * as subject. 
	 */
	
	public List<OnkiStatement> findForward(OnkiResource ores, Statement stmt);
	
    /**
	 * Generate statements starting from RDF statements where the current resource is
	 * as object.
	 */
	
	public List<OnkiStatement> findBackward(OnkiResource ores);
}
