package fi.helsinki.cs.seco.onki.service;

import java.util.Collection;

/**
 * Defines the ONKI API (published as AJAX & SOAP).
 */

public interface IOnkiQuery {
	public OnkiQueryResults search(String query, String lang, Integer maxHits, Collection<String> types, Collection<String> parents, Collection<String> groups);
	public Collection<String> getAvailableLanguages();
	public Collection<String> getAvailableTypeUris();
	public OnkiQueryResult getLabel(String uri, String lang);
	public OnkiQueryResults expandQuery(Collection<String> uris, String lang, Integer maxHits, Collection<String> types);
	public Collection<OnkiHierarchyRelation> getConceptTree(String uri, String lang);
	public Collection<Statement> getProperties(String uri, Collection<String> propertyUris, String lang);
}