package fi.helsinki.cs.seco.onki.service;

/**
 * Represents metadata of a result set returned by ONKI API's search method.
 */

public class OnkiQueryResultsMetadata {
	
	private int totalHits;
	private int containingHits;
	
	public OnkiQueryResultsMetadata(int totalHits, int containingHits) {
		this.totalHits = totalHits;
		this.containingHits = containingHits;
	}
	
	public int getTotalHitsAmount() {
		return this.totalHits;
	}
	
	public int getContainingHitsAmount() {
		return this.containingHits;
	}
	
	public int getMoreHitsAmount() {
		return this.getTotalHitsAmount() - this.getContainingHitsAmount();
	}
	
	public boolean isMoreHits() {
		return this.getMoreHitsAmount() > 0;
	}
}