package fi.helsinki.cs.seco.onki.servlet;

import java.util.Map;
import java.util.Map.Entry;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.restlet.Context;
import org.restlet.data.Form;
import org.restlet.data.MediaType;
import org.restlet.data.Parameter;
import org.restlet.data.Request;
import org.restlet.data.Response;
import org.restlet.ext.json.JsonRepresentation;
import org.restlet.resource.Representation;
import org.restlet.resource.ResourceException;
import org.restlet.resource.Variant;

/**
 * Represents label prefixes of concepts the concept index contains.
 */

public class GetAvailableLabelPrefixesResource extends BaseResource {
	
	String lang;
	Map<String, Integer> map;
	
	public GetAvailableLabelPrefixesResource(Context context, Request request, Response response) {  
		super(context, request, response);  
	
		Form query = getRequest().getResourceRef().getQueryAsForm();
		 
		for (Parameter param : query)
			if (param.getName().equals("l"))
				this.lang = param.getValue();
		
		this.map = getAvailableLabelPrefixes(lang);
		
		getVariants().add(new Variant(MediaType.APPLICATION_JSON));
	}
	
	/** 
	 * Returns a full representation for a given variant. 
	 */  
	@Override  
	public Representation represent(Variant variant) throws ResourceException {  
		JSONArray array = new JSONArray();
		if (this.map != null) {
			for (Entry<String, Integer> entry : this.map.entrySet()) {
				JSONObject obj = new JSONObject();
				try {
					obj.put(entry.getKey(), entry.getValue());
				} 
				catch (JSONException e) {
					e.printStackTrace();
				}
				array.put(obj);
			}
		}

		JsonRepresentation representation = new JsonRepresentation(array);
		representation.setModificationDate(getLastModified());
		representation.setExpirationDate(getExpires());
		this.finalize();
	    return representation;
	}
}