<!-- $Id: anno-demo.jsp,v 1.0 2005/05/16 10:28:42 vpkomula Exp $ -->

<style type="text/css">
<!--
h4 {
  margin-top: 15px;
  margin-bottom: 0px;
  padding: 3px;
  background: #dddddd;
}
// -->
</style>

<table class="anno-content" border="0" width="100%" align="center" cellpadding="0" cellspacing="0">
<!-- Description -->
<tr class="header-title">
	<td class="anno-title">&nbsp;1. Introduction</td>
</tr>
<tr>
	<td class="anno-text">
	
	<ul type="square">
		<li><b>Context</b>
		<ul type="square">
			<li>Let's assume that you are cataloging your collections such as books, museum items, articles, etc. with web-based application and
			you want to describe them using some controlled vocabulary.
			</li>
			<li>The Form below labeled <i>Demo</i>  roughly simulates this kind of an cataloging system.</li>
			<li>In this example Items are cataloged with the listed descriptive entities.</li>
				
			<li>One could have any number of fields matching the needs of the cataloging system.</li>
			<li><b>One</b> way of doing this is:
			<ol>
				<li>Open thesauri / ontology browser.</li>
				<li>Search the corresponging term/URI.
				<li>Copy-paste the found term or URI's to corresponding field.</li>
			</ol>
			<li><b>More feasible</b> way of doing this is by hooking software to OnkiBrowser:
			<ol>				
				<li>For each field there is a "Find"-button for finding concepts from Ontology repository and buttons for fetching them back to your cataloging app. In this example there is also an autocompletition concept find-utility attached to field <i>FFFF</i>. Just try typing something to this field for seeing it in action.</li>
				<li>When Items are indexed with URI's, one can use efficent multi-faceted search engines to explore collections, such as <a target="new" href="http://www.museosuomi.fi">Museosuomi</a>.</li>
				<li>Typing errors are history, mechanism forces you to use right vacabulary and guides you to find the right concepts.</li>
			</ol>
			<li>The integration explained here is quite easy and straightforward to implement.</li>
		</ul>
		</li>
		</br>
		
		<li><b>Step 1 (Fetch URI to field <i>Item Type</i>)</b>
		<ul type="square">
		    <li>In this example, ths field represents the items type. For example, is it a book, helmet, knife or perhaps boots?</li>
			<li>Click "Find"-button associated to field <i>Item Type</i>. This opens up OnkiBrowser in a new window.</li>
			<li>Browse in the concept-hierarchy on the left-hand side of the screen or search them by keyword. Try finding 'Kengät' from the repository</li>
			<li>When the concept you were looking for is found, click the "fetch concept"-button on the OnkiBrowser.</li>
			<li>Now the selected URI is transfered to your application.</li>
		</ul>
		</br>
		</li>
		
		<li><b>Step 2 (Fetch URI and label to field <i>Found from</i>)</b>
		<ul type="square">
		    <li></li>
			<li>Search concept just like in Step 1</li>
			<li>When fetching you can see that also the label of the concept is imported.</li>
		</ul>
		</li>
		</br>
		
		<li><b>Step 3 (Find URI's with autocompletition to field <i>Describing URI's</i>)</b>
		<ul type="square">
			<li>Try typing something to field <i>search</i></li>
			<li>Select the concepts of your choice by clicking the concept</li>
		</ul>
		</li>
		</br>
	</ul>
	</td>
</tr>
<tr>
	<td>&nbsp;</td>
</tr>

<!-- Demo -->
<tr>
	<td class="anno-title">&nbsp;2. Demo</td>
</tr>
<tr>
	<td class="anno-text">
	<form name="onkiRefererForm2">
	<div align="center">
	&nbsp;<br>
	<table border="0" width="95%" class="catalog" cellpadding="0" cellspacing="0">	
	<tr>
		<td colspan="2" bgcolor="#CCCCCC"><b>&nbsp;Collection Cataloging System view</b></td>
	</tr>
	<tr>
		<td valign="top">&nbsp;<b>Item description:</b></td><td width="70%"><textarea class="textfield" name="elementId" 
		rows="5" cols="68">Leather boots found from Helsinki area at 18th century</textarea></td>
	</tr>
	
	<tr>
	<td colspan="2">
	<h4>Step 1: Fetch concept from ONKI</h4>
	</td>
	</tr>
	
	<tr>
		<td>&nbsp;<b>Item URI: </b></td><td><input class="textfield" type="text" name="typeUri" id="typeUriId" size="70" 
		value=""><input type="button" onClick="openOnki('../../OnkiServlet?', 'typeUriId', null,' ',null)" value="Find from ONKI"></td>
	</tr>
	
	<tr>
	<td colspan="2">
	<h4>Step 2: Fetch subconcept of the preselected concept (yso:jalkineet) from ONKI</h4>
	</td>
	</tr>
	
    <tr>
		<td>&nbsp;<b>Item URI: </b></td><td><input class="textfield" type="text" name="typeUri" id="typeUriIdRange" size="70" value=""><input 
		type="button" onClick="openOnki('../../OnkiServlet?', 'typeUriIdRange', 'http://yso.fi/YSO#jalkineet')" value="Find from ONKI"></td>
	</tr>
	
	<tr>
	<td colspan="2">
	<h4>Step 3: Fetch a concept and it's label from ONKI</h4>
	</td>
	</tr>
	
	<tr>
		<td>&nbsp;<b>Item label:</b></td><td><input class="textfield" type="text" 
		name="fetch3concepts_labels" id="fetch3concepts_labels" size="70" value=""></td>
	</tr>
	
	<tr>
		<td>&nbsp;<b>Item URI:</b></td><td><input class="textfield" type="text" name="fetch3concepts" 
		id="fetch3concepts" size="70" value="">
		<input type="button" onClick="openOnki('../../OnkiServlet?', 'fetch3concepts')" value="Find from ONKI"></td>
	</tr>

	<tr>
	<td colspan="2">
	<h4>Step 4: Fetch a concept with autocompletition from ONKI</h4>
	</td>
	</tr>

	<tr>
		<td>&nbsp;<b>Item's describing URI's</b></td><td><textarea class="textfield" type="text" id="definitionUri" 
		name="definitionUri" cols="100" rows="10"></textarea></td>
	</tr>
	<tr>
		<td>&nbsp;<b>Search </b><font color="#999999" size="-1">[Step 3]</font></td><td><input class="textfield" type="text" 
		onKeyUp="doOnkiQuery('../../OnkiServlet?', this.value, 'definitionUri', 'onkiAutocomplete')" 
		autocomplete="off" name="searchField" size="70" value="" 
		onFocus="maximizeOnkiDiv('onkiAutocomplete')" 
 		onBlur="hideOnkiDiv('onkiAutocomplete', 0.1)"
		><div id="onkiAutocomplete" class="onkiAutocomplete" align="left"></td>
	</tr>
<!--
 -->
	<tr>
	<td colspan="2">
	<h4>Step 5: Fetch a subconcept of the given concept from ONKI</h4>
	</td>
	</tr>
	
	<!-- Range -->
	<tr>
		<td>&nbsp;<b>Item's describing URI's</b></td><td><input class="textfield" type="text" id="definitionRangeUri" name="definitionRangeUri" size="70" value=""></td>
	</tr>
	<tr>
		<td>&nbsp;<b>Search w/ rdfs:range </b><font color="#999999" size="-1">[Step 3]</font></td><td><input class="textfield" type="text" onKeyUp="sendOnkiXMLQuery('../../OnkiServlet?', this.value, 'definitionRangeUri', ' ', 'http://yso.fi/YSO#muuttuva','autocompleteRange', 'autocompleteRange')" autocomplete="off" name="searchField" size="70" value=""><div id="autocompleteRange" class="autobox" align="left"></td>
	</tr>
	
	<tr>
		<td>&nbsp;<br>&nbsp;&nbsp;</td>
	</tr>
	</table>
	</div>
	</form>
	&nbsp;</br>
	</td>
</tr>
</table>