dojo.provide("semweb.graph.Node");

dojo.require("prototype.prototype");

semweb.graph.Node = Class.create();

semweb.graph.Node.prototype = {
  initialize: function(graph, id, value) {
    this.x = 0.0;
    this.y = 0.0;
    this.xdelta = 0.0;
    this.ydelta = 0.0;
    this.graph = graph;
    this.id = id;
    this.edgesOutHash = $H({});
    this.edgesOutList = [];
    this.edgesInHash = $H({});
    if (typeof value == 'string') {
      this.value = Element.extend(MochiKit.DOM.DIV());
      document.getElementsByTagName('body')[0].appendChild(this.value);
      this.value.appendChild(document.createTextNode(value));
//      this.width = 5*value.length;
//      this.height = 13;
//      this.radius = 13*value.length;
    } else {
      this.value = value;
    }
      this.value.style.position='absolute';
      Object.extend(this,this.value.getDimensions());
      if (this.width>this.height) this.radius=this.width;
        else this.radius=this.height;
    this.dirty = false;
  },
  
  remove: function() {
    this.edgesOutHash.each(function(item) {
       var target = this.graph.getNode(item.key);
       delete target.edgesInHash[this.id];
    }.bind(this));
    this.edgesInHash.each(function(item) {
       var target = this.graph.getNode(item.key);
       delete target.edgesOutHash[this.id];
       target.dirty=true;
    }.bind(this));
    this.value.hide();
    delete this.graph.nodeHash[this.id];
    this.graph.dirty=true;
  },
  
  getEdgesIn: function() {
    return this.edgesInHash.collect(function(pair) {
      return this.graph.getNode(pair[0]);
    }.bind(this));
  },

  getEdgesOut: function() {
    this.cache();
    return this.edgesOutList;
  },
  
  addEdge: function(targetNode) {
    this.edgesOutHash[targetNode.id] = 1;
    targetNode.edgesInHash[this.id] = 1;
    this.dirty = true;
  },
  
  removeEdge: function(targetNode) {
    delete this.edgesOutHash[targetNode.id];
    delete targetNode.edgesInHash[this.id];
    this.dirty = true;
  },
  
  cache: function() {
    if (this.dirty) { 
      this.edgesOutList = this.edgesOutHash.collect(function(pair) {
        return this.graph.getNode(pair[0]);
      }.bind(this));
      this.dirty = false;
    }
  }
  
};