package fi.seco.semweb.infrastructure.dwr;

import org.directwebremoting.create.AbstractCreator;
import org.directwebremoting.util.LocalUtil;

import fi.seco.semweb.infrastructure.SecoRegistry;

public class SecoRegistryCreator extends AbstractCreator {

	private String serviceName;
	private Class<? extends Object> serviceClass;

	public Class<? extends Object> getServiceClass() {
		return serviceClass;
	}

	@SuppressWarnings("unchecked")
	public void setServiceClass(String serviceClassName) {
		try {
			this.serviceClass = LocalUtil.classForName(serviceClassName);
		} catch (ClassNotFoundException e) {
			throw new IllegalArgumentException("Class not found: "+serviceClassName);
		}
	}

	public String getServiceName() {
		return serviceName;
	}

	public void setServiceName(String serviceName) {
		this.serviceName = serviceName;
	}

	public Object getInstance() throws InstantiationException {
		if (serviceClass!=null && serviceName!=null) return SecoRegistry.getService(serviceName,serviceClass);
		else if (serviceClass!=null) return SecoRegistry.getService(serviceClass);
		else return SecoRegistry.getService(serviceName);
	}

	public Class<? extends Object> getType() {
		if (serviceClass!=null) return serviceClass;
		return SecoRegistry.getService(serviceName).getClass();
   }


}
