package fi.seco.semweb.infrastructure.jena;

import java.io.File;
import java.util.LinkedList;
import java.util.List;

public class JenaComboTDBModelSource extends JenaModelSource implements IJenaUrlModelSource {
	private String location;
	private List<String> urls = new LinkedList<String>();

	public JenaComboTDBModelSource() { }

	public JenaComboTDBModelSource(String key, String location, List<String> urls) {
		super(key);
		this.location=location;
		this.urls=urls;
	}

	/**
	 * @return Returns the uri.
	 */
	public List<String> getUrls() {
		return urls;
	}
	
	/**
	 * @param uri The uri to set.
	 */
	public void addUrl(String url) {
		this.urls.add(url);
	}

	@Override
	public String toString() {
		return "key: "+getKey()+", urls: "+getUrls();
	}

	public void setUrl(String url) {
		this.urls.add(url);
	}

	public void setUrls(List<String> urls) {
		this.urls=urls;
	}

	/**
	 * @return Returns the location.
	 */
	public String getLocation() {
		return location;
	}
	
	/**
	 * @param key The location to set.
	 */
	public void setLocation(String location) {
		this.location = location;
	}
	
	public long getLastModified() {
		File dir = new File(this.getLocation());
		long lm = dir.lastModified();
		if (dir.listFiles() != null)
			for (File file : dir.listFiles())
				if (file.lastModified() > lm)
					lm = file.lastModified();
		return lm;
	}
}