package fi.seco.semweb.infrastructure.jena;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.LinkedList;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class JenaUrlModelSource extends JenaModelSource implements IJenaUrlModelSource {

	private static Log log = LogFactory.getLog(JenaUrlModelSource.class);
	
	private String key;
	private List<String> urls = new LinkedList<String>();
	//private String format;

	public JenaUrlModelSource() { }

	//public JenaUrlModelSource(String key, List<String> urls, String format) {
	public JenaUrlModelSource(String key, List<String> urls) {
		this.key=key;
		this.urls=urls;
		//this.format=format;
	}
	/**
	 * @return Returns the key.
	 */
	@Override
	public String getKey() {
		return key;
	}
	/**
	 * @param key The key to set.
	 */
	@Override
	public void setKey(String key) {
		this.key = key;
	}
	/**
	 * @return Returns the uri.
	 */
	public List<String> getUrls() {
		return urls;
	}
	/**
	 * @param uri The uri to set.
	 */
	public void addUrl(String url) {
		this.urls.add(url);
	}

	public void setUrl(String url) {
		this.urls.add(url);
	}

	public void setUrls(List<String> urls) {
		this.urls=urls;
	}
	/**
	 * @return Returns the format.
	 */

	/*
	public String getFormat() {
		return format;
	}
	*/
	/**
	 * @param key The format to set.
	 */
	/*
	public void setFormat(String format) {
		this.format = format;
	}
	*/
	
	public long getLastModified() {
		long lastlm = 0;
		for (String url : urls)
			try {
				long lm = new URL(url).openConnection().getLastModified();
				if (lm>lastlm) lastlm=lm;
			} catch (MalformedURLException e) {
				log.error("Malformed URL " +url+" when getting last modified date of Jena model "+getKey(),e);
			} catch (IOException e) {
				log.error("Read from URL "+url+" failed when getting last modified date of Jena model "+getKey(),e);
			}
		return lastlm;
	}
}