package fi.seco.semweb.model;

import org.apache.commons.lang.ObjectUtils;

import com.hp.hpl.jena.ontology.Individual;
import com.hp.hpl.jena.ontology.OntClass;
import com.hp.hpl.jena.ontology.OntModel;
import com.hp.hpl.jena.ontology.OntProperty;
import com.hp.hpl.jena.ontology.OntResource;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.Resource;

import fi.seco.semweb.util.JenaHelper;

public class OntModelHoldingObject extends ModelHoldingObject {

	private static final long serialVersionUID = 1L;

	public OntModelHoldingObject(OntModel model) {
		super(model);
	}

	public OntResource or(Resource r) {
		return JenaHelper.or((OntModel)model,r);
	}

	public OntResource or(String uri) {
		return JenaHelper.or((OntModel)model,uri);
	}

	public OntProperty op(String uri) {
		return JenaHelper.op((OntModel)model,uri);
	}

	public Individual oi(OntModel model, Resource classResource) {
		return JenaHelper.oi(model,classResource);
	}

	public Individual oi(OntModel model, String uri, Resource classResource) {
		return JenaHelper.oi(model,uri,classResource);
	}

	public Individual oi(OntModel model, String uri, String classUri) {
		return JenaHelper.oi(model,uri,classUri);
	}

	public OntClass oc(OntResource resource) {
		return JenaHelper.oc((OntModel) model,resource);
	}

	public OntClass oc(String uri) {
		return JenaHelper.oc((OntModel)model,uri);
	}

	@Override
	public Model getModel() {
		return model;
	}

	public OntModel getOntModel() {
		return (OntModel) model;
	}

	@Override
	public String toString() {
		return ObjectUtils.identityToString(this);
	}

}
