package fi.seco.semweb.service.poka;

import java.util.HashSet;

//Verbivakiot



public class Configuration {

/**
 * Kehysmaailman oletusnimiavaruus
 */
	public static final String DEFAULTFRAMENAMESPACE = "http://www.seco.hut.fi/ns/2005/10/alm#";

/**
 * Tiedostojen oletussijainnit (katso alla)
 */
	private static String defaultPath = "/home/alm/ontologies/ontologies/poka/";
									//DEMOSSA: "/docume~1/seco/Desktop/poka/Framerton/";  
		

/**
 * Nimikonfiguraatiotiedoston oletussijainti
 * 
 * TODO: poista tämä ja korvaa suorilla viitteillä
 * name.list ja notAName.list -tiedostoihin
 * 
 */
	
	public static final String NAMECONFIGFILE = 
		"/common/home/alm/workspace/Trunk/fi/seco/semweb/service/poka/name/" +
		"name.config";
		//"/docume~1/seco/Desktop/poka/Framerton/fi/seco/semweb/service/poka/name/" +
		//"name.config";
		
		
	    
//VERBIEN & KEHYSTEN OMINAISUUDET
	
	//TODO: lisäillään ja poistellaan tarvittaessa 
	public static final int AGENT         = 0;
	public static final int PATIENT       = 1;
	public static final int PLACE         = 2;
	public static final int TIME          = 3;
	public static final int MATERIAL      = 4;
	public static final int INSTRUMENT    = 5;
	public static final int RELATIVEPLACE = 6;
	public static final int ABSOLUTEPLACE = 7;
	public static final int ABSOLUTE_TIME = 8;
	public static final int HUMANAGENT    = 9; //POIS!
	public static final int ANIMALAGENT   = 10;//POIS!
	public static final int EFFECTOR      = 11;
	public static final int RESOURCE      = 12; //instrument + material
	public static final int RELATIVE_TIME = 13;
	public static final int GOAL          = 14;
	public static final int DESTINATION   = 15;
	public static final int ESSENCE       = 16;
	public static int VERBSIZE = 17;
	
	//ominaisuuksien nimet ontologiassa vakioiden takana (STR~String)
	public static final String AGENT_STR          = "agent";
	public static final String PATIENT_STR        = "patient";
	public static final String PLACE_STR          = "place";
	public static final String TIME_STR           = "time";
	public static final String MATERIAL_STR       = "material";
	public static final String INSTRUMENT_STR     = "instrument";
	public static final String RELATIVE_PLACE_STR = "relative_place";
	public static final String ABSOLUTE_PLACE_STR = "absolute_place";
	public static final String ABSOLUTE_TIME_STR  = "absolute_time";
	public static final String HUMAN_AGENT_STR    = "human_agent";
	public static final String ANIMAL_AGENT_STR   = "animal";
	public static final String EFFECTOR_STR		  = "effector";
	public static final String RESOURCE_STR		  = "resource";
	public static final String RELATIVE_TIME_STR  = "relative_time";
	public static final String GOAL_STR			  = "goal";
	public static final String DESTINATION_STR    = "destination";
	public static final String ESSENCE_STR        = "essence";

/**
 * Taulukko lemmatisoiduista verbeistä, jotka voivat
 * aiheuttaa tietyissä tapauksissa prova-sääntöjä
 * kehyksen hylkäämisen:
 * >oli< 	maalannut
 * >jatkoi< maalaamista (?)
 * >alkoi< 	maalaamaan (?)
 * 
 */
	public static final String[] DISCARDVERBS =
		{"olla"};

	//YSOLEMMAt
	public static void setDefaultPath(String path) {
		defaultPath = path;
	}
	public static String getNeulemmas() {
		return defaultPath+"Terms-all.rdf";
	}
	public static String getPlaceLemmas() {
		return defaultPath+"PaikkaTerms.rdf";
	}
	public static String getPlaces() {
		return defaultPath+"Paikat.owl"; 
	}
	public static String getNeuOntology() {
		return defaultPath+"YSO-All.owl";
	}
	public static String getYsoNoYsa() { //FOBISSA
		return defaultPath+"YSO-no-YSA.owl";
	}
	public static String getVerbs() {
		return defaultPath+"Verbs.rdf";
	}
	public static String getOpasInstanceFile() {
		return defaultPath + "Opas.rdf";
	}
	public static String getOpasTermFile() {
		return defaultPath + "OpasTerms.rdf";
	}
	public static String getFrameVerbs() {
		return defaultPath+"frame/frameUTF8rakenne2.owl";
	}
	public static String getYsaGroups() {
		return defaultPath + "YSA-Groups.owl";
	}
//--------------------------FRAMET alla
	public static String getNeuFrameVerbs() { //uudet Cookkimaiset verbit (käytetään FOBissa)
		return defaultPath+"frame/frameCookinMukaan.owl";
	}
	public static String getOldFullModel() {
		return defaultPath+"frame/FrameModelFull.owl";
	}
	public static String getNewFullModel() {
		return defaultPath+"frame/CookFull2.owl";
	}
	public static String getVerbTermsFull() {
		return defaultPath+"frame/Term-verbs-full.rdf";
	}
	public static String getBeVerbTermsFull() {
		return defaultPath+"frame/Term-verbs-full-with-be.rdf";
	}
	public static String getCookVerbTerms() {
		return defaultPath+"frame/Term-verbs-full-cook.rdf";
	}



}
