<xsl:stylesheet 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  version="1.0">
  <!-- xsl:output method="html"/ --> 
   <xsl:template match="/">
    <html><body>
       <xsl:apply-templates select="/A/S" />
    </body></html>
  </xsl:template>

<!-- SELITYKSET TAGEILLE:

BS / T		BASE / TEXT
BS / L		BASE / LEMMA
UP / T		UPPERCASE / TEXT
UP / L		UPPERCASE / LEMMA
UP / MO		UPPERCASE / MORPHO
UP / SYN	UPPERCASE / SYNTAX
SY / T		SYMBOL / TEXT
NM / T		NUMERAL / TEXT
NM / L		NUMERAL / LEMMA
PN / T		PRONOUN / TEXT
PN / L		PRONOUN / LEMMA
AD / T		ADJECTIVE / TEXT
AD / L		ADJECTIVE / LEMMA
VB / T		VERB / TEXT
VB / L		VERB / LEMMA
P		PARAGRAPH
OT / T		OTHER (tags from FDG)
C / T		(IDENTIFIED) CONCEPT / TEXT
C / I		(IDENTIFIED) CONCEPT / INFORMATION
C / L		(IDENTIFIED) CONCEPT / LEMMA
R / T		(IDENTIFIED) REGULAR EXPRESSION / TEXT
R / I		(IDENTIFIED) REGULAR EXPRESSION / INFORMATION
NA / T		(IDENTIFIED) NAME / TEXT
NA / I		(IDENTIFIED) NAME / INFORMATION
V / T 		(IDENTIFIED) VERB / TEXT
V / I 		(IDENTIFIED) VERB / INFORMATION
V / L 		(IDENTIFIED) VERB / LEMMA
PL / T          (IDENTIFIED) PLACE / TEXT
PL / I		(IDENTIFIED) PLACE / INFORMATION
PL / L		(IDENTIFIED) CONCEPT / LEMMA
-->
  <xsl:template match="/A/S">
    <p> <xsl:apply-templates select="BS/T|
                                     BS/L|
                                     UP/T|
				     UP/L|
				     UP/MO|
                                     UP/SYN|
				     SY/T|
                                     NM/T|
                                     NM/L|
                                     PN/T|
				     PN/L|
                                     AD/T|
				     AD/L|
                                     VB/T|
				     VB/L|
                                     P|
                                     OT/T|
                                     C/T| 
				     C/I|
				     C/L|
				     V/T|
                                     V/I|
                                     V/L| 
				     R/T|
				     PL/T|
                                     PL/I|
                                     PL/L| 
				     R/I| 
                                     NA/T| 
                                     NA/I|
				     */MO|*/SYN|*/DEP"/> </p>
  </xsl:template>


  <xsl:template match="P">
	<p />
  </xsl:template>

  <xsl:template match="UP/T|SY/T|NM/T|PN/T|AD/T|OT/T">
     <xsl:apply-templates select="text() " /><xsl:text> </xsl:text>
  </xsl:template>

  <xsl:template match="VB/T">
      <font color="green"><b> <xsl:apply-templates select="text()"/> </b></font><xsl:text> </xsl:text>
  </xsl:template>

  <xsl:template match="NA/T">
      <font COLOR="#FF33FF"><b> <xsl:apply-templates select="text()"/> </b></font><xsl:text> </xsl:text>
  </xsl:template>

  <xsl:template match="NA/I">
      <b> <xsl:apply-templates select="text()"/> </b><xsl:text> </xsl:text>
  </xsl:template>

  <xsl:template match="BS/T">
      <xsl:apply-templates select="text()"/><xsl:text> </xsl:text>
  </xsl:template>
  <xsl:template match="BS/L|AD/L|UP/L|NM/L|PN/L|VB/L|SY/L|UP/MO|UP/SYN">
      <xsl:text></xsl:text>
  </xsl:template>

  <xsl:template match="C/T">
      <b> <xsl:apply-templates select="text()"/> </b><xsl:text> </xsl:text>
  </xsl:template>
  <xsl:template match="C/I">
      <font COLOR="#306EFF"><b>(<xsl:apply-templates select="text()"/>)</b></font><xsl:text> </xsl:text>
  </xsl:template>
  <xsl:template match="C/L">
      <xsl:text></xsl:text>
  </xsl:template>

  <xsl:template match="V/T">
      <b> <xsl:apply-templates select="text()"/> </b><xsl:text> </xsl:text>
  </xsl:template>
  <xsl:template match="V/I">
      <font COLOR="green"><b>(<xsl:apply-templates select="text()"/>)</b></font><xsl:text> </xsl:text>
  </xsl:template>
  <xsl:template match="V/L">
      <xsl:text></xsl:text>
  </xsl:template>

  <xsl:template match="PL/T">
      <b> <xsl:apply-templates select="text()"/> </b><xsl:text> </xsl:text>
  </xsl:template>
  <xsl:template match="PL/I">
      <font COLOR="purple"><b>(<xsl:apply-templates select="text()"/>)</b></font><xsl:text> </xsl:text>
  </xsl:template>
  <xsl:template match="PL/L">
      <xsl:text></xsl:text>
  </xsl:template>


  <xsl:template match="R/T">
      <b> <xsl:apply-templates select="text()"/> </b><xsl:text> </xsl:text>
  </xsl:template>
  <xsl:template match="R/I">
      <font COLOR="red"><b>(<xsl:apply-templates select="text()"/>)</b></font><xsl:text> </xsl:text>
  </xsl:template>

  <xsl:template match="*/MO|*/SYN|*/DEP">
      <xsl:text></xsl:text>
  </xsl:template>

</xsl:stylesheet>


