package fi.seco.semweb.service.poka.util;
/**
 * Verbiontologian kyselyrajapinta
 */
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.hp.hpl.jena.query.QueryExecutionFactory;
import com.hp.hpl.jena.query.QueryFactory;
import com.hp.hpl.jena.query.QuerySolution;
import com.hp.hpl.jena.query.ResultSet;
import com.hp.hpl.jena.rdf.model.Literal;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.rdql.Query;
import com.hp.hpl.jena.rdql.QueryEngine;
import com.hp.hpl.jena.rdql.QueryException;
import com.hp.hpl.jena.rdql.QueryExecution;
import com.hp.hpl.jena.rdql.QueryResults;
import com.hp.hpl.jena.rdql.ResultBinding;


public class VerbQuery extends TermoQuery {
	private static final Log log = LogFactory.getLog(VerbQuery.class);
	
	public VerbQuery(String filename, String encoding) {
		super(filename, encoding);
	}

	public VerbQuery(Model model) {
		super(model);
	}

/**
 * TODO: tällä hetkellä ei yläluokkia, ei palauteta mitään 
 */
	public String getUpper(String uri) {
		return "";
	}
/**
 * Palauttaa verbijoukon. Joukosta
 * tarkistetaan onko verbi olemassa.
 * syö muistia, mutta nopeuttaa käsittelyä
 * 
 */
	public HashSet<String> getVerbs() {

		String qString = 
			"SELECT ?label " +
			"WHERE (?concept, <oma:verblabel>, ?label) " +
	        "USING oma FOR <http://www.seco.hut.fi/ns/2006/02/alm#>";
		
		com.hp.hpl.jena.query.Query q = null;
		try {
			q = QueryFactory.create(qString, com.hp.hpl.jena.query.Syntax.syntaxRDQL);
		} catch(com.hp.hpl.jena.query.QueryException e) {
			log.error("Virheellinen kyselymerkkijonon sisältö:\n"+qString+"\nVirhe:"+e);
		}

		com.hp.hpl.jena.query.QueryExecution qe = QueryExecutionFactory.create(q, m);
		HashSet <String> set = new HashSet <String> (600); //init 600
		
		try {
			ResultSet results = qe.execSelect();
	
			for( ; results.hasNext() ;) {
				QuerySolution res = results.nextSolution();
				set.add(((Literal)res.get("label")).getString());
			}
		} finally { qe.close(); }
		return set;
	}
	
	/**
	 * Palauttaa verbiä vastaavan käsitteen
	 * TODO: verbQueryyn
	 *
	 */

	public List<String> getVerbs(String verb) {

		String qString = 
			"SELECT ?concept " +
			"WHERE (?concept, <oma:verblabel>, \""+verb+"\") " +
	        "USING oma FOR <http://www.seco.hut.fi/ns/2006/02/alm#>";
		
		com.hp.hpl.jena.query.Query q = null;
		try {
			q = QueryFactory.create(qString, com.hp.hpl.jena.query.Syntax.syntaxRDQL);
		} catch(com.hp.hpl.jena.query.QueryException e) {
			log.error("Virheellinen kyselymerkkijonon sisältö:\n"+qString+"\nVirhe:"+e);
		}

		com.hp.hpl.jena.query.QueryExecution qe = QueryExecutionFactory.create(q, m);
		List <String> result = new ArrayList<String>();
		
		try {
			ResultSet results = qe.execSelect();
					
			for(; results.hasNext() ;) {
				QuerySolution res = results.nextSolution();
				result.add(((Resource)res.get("concept")).getURI());		
			}
		} finally { qe.close(); }	
			
		return result;
	}

	
}
