package fi.seco.semweb.service.view.keyword;

import org.apache.lucene.index.Term;
import org.apache.lucene.search.Query;
import org.apache.lucene.search.WildcardQuery;

import fi.seco.semweb.service.search.query.ILuceneSelectorState;


public class KeywordSelectorState implements ILuceneSelectorState {

	private String keyword;
	private String field;
	
	public KeywordSelectorState(String field) {
		this.field=field;
	}
	
	public KeywordSelectorState(String field, String keyword) {
		this.field=field;
		this.keyword = keyword;
	}
	
	public void setKeyword(String keyword) {
		this.keyword = keyword;
	}
	
	public String getKeyword() {
		return keyword;
	}
	
	public String getCacheKey() {
		return field+":"+keyword;
	}

	public Query getQuery() {
		return new WildcardQuery(new Term(field,keyword.toLowerCase()+"*"));
	}

}
