package fi.seco.semweb.util.collection;

import java.util.Collection;
import java.util.Iterator;

import fi.seco.semweb.util.iterator.AMappingIterator;

public abstract class AMappingCollection<O,E> implements Collection<E> {

	Collection<? extends O> col;

	public AMappingCollection(Collection<? extends O> col) {
		this.col=col;
	}

	public Iterator<E> iterator() {
		return new AMappingIterator<O,E>(col.iterator()) {

			@Override
			public E map(O arg0) {
				return AMappingCollection.this.map(arg0);
			}

		};
	}

	public abstract E map(O a);

	public int size() {
		return col.size();
	}

	public boolean isEmpty() {
		return col.isEmpty();
	}

	public boolean contains(Object o) {
		throw new UnsupportedOperationException();
	}

	public Object[] toArray() {
		throw new UnsupportedOperationException();
	}

	public <T> T[] toArray(T[] a) {
		throw new UnsupportedOperationException();
	}

	public boolean add(E o) {
		throw new UnsupportedOperationException();
	}

	public boolean remove(Object o) {
		throw new UnsupportedOperationException();
	}

	@SuppressWarnings("unchecked")
	public boolean containsAll(Collection c) {
		throw new UnsupportedOperationException();
	}

	public boolean addAll(Collection<? extends E> c) {
		throw new UnsupportedOperationException();
	}

	@SuppressWarnings("unchecked")
	public boolean removeAll(Collection c) {
		throw new UnsupportedOperationException();
	}

	@SuppressWarnings("unchecked")
	public boolean retainAll(Collection c) {
		throw new UnsupportedOperationException();
	}

	public void clear() {
		col.clear();
	}

}
