package fi.seco.semweb.util.collection.primitive;

import java.util.Collection;
import java.util.Iterator;

import org.apache.commons.collections.primitives.LongCollection;

import fi.seco.semweb.util.iterator.primitive.ALongToObjectMappingIterator;

public abstract class ALongToObjectMappingCollection<E> implements Collection<E> {

	LongCollection col;

	public ALongToObjectMappingCollection(LongCollection col) {
		this.col=col;
	}

	public Iterator<E> iterator() {
		return new ALongToObjectMappingIterator<E>(col.iterator()) {

			@Override
			public E map(long arg0) {
				return ALongToObjectMappingCollection.this.map(arg0);
			}

		};
	}

	public abstract E map(long l);

	public int size() {
		return col.size();
	}

	public boolean isEmpty() {
		return col.isEmpty();
	}

	public boolean contains(Object o) {
		throw new UnsupportedOperationException();
	}

	public Object[] toArray() {
		throw new UnsupportedOperationException();
	}

	public <T> T[] toArray(T[] a) {
		throw new UnsupportedOperationException();
	}

	public boolean add(E o) {
		throw new UnsupportedOperationException();
	}

	public boolean remove(Object o) {
		throw new UnsupportedOperationException();
	}

	@SuppressWarnings("unchecked")
	public boolean containsAll(Collection c) {
		throw new UnsupportedOperationException();
	}

	public boolean addAll(Collection<? extends E> c) {
		throw new UnsupportedOperationException();
	}

	@SuppressWarnings("unchecked")
	public boolean removeAll(Collection c) {
		throw new UnsupportedOperationException();
	}

	@SuppressWarnings("unchecked")
	public boolean retainAll(Collection c) {
		throw new UnsupportedOperationException();
	}

	public void clear() {
		col.clear();
	}

}
