package fi.seco.semweb.util.collection.primitive;

import java.util.Iterator;

import org.apache.commons.collections.primitives.ArrayLongList;
import org.apache.commons.collections.primitives.LongCollection;
import org.apache.commons.collections.primitives.LongIterator;

import fi.seco.semweb.util.iterator.IIterableIterator;

public abstract class AObjectIteratorToLongMappingCollection<O> implements LongCollection {

	private LongCollection col=new ArrayLongList();
	
	@SuppressWarnings("unchecked")
	public AObjectIteratorToLongMappingCollection(IIterableIterator<? extends O> iter) {
		this((Iterator<? extends O>)iter);
	}
	
	public AObjectIteratorToLongMappingCollection(Iterator<? extends O> iter) {
		for (;iter.hasNext();) col.add(map(iter.next()));
	}

	public AObjectIteratorToLongMappingCollection(Iterable<? extends O> col) {
  	  this(col.iterator());
	}
	
	public abstract long map(O a);

	public boolean add(long arg0) {
		return col.add(arg0);
	}

	public boolean addAll(LongCollection arg0) {
		return col.addAll(arg0);
	}

	public void clear() {
		col.clear();
	}

	public boolean contains(long arg0) {
		return col.contains(arg0);
	}

	public boolean containsAll(LongCollection arg0) {
		return col.containsAll(arg0);
	}

	public boolean isEmpty() {
		return col.isEmpty();
	}

	public LongIterator iterator() {
		return col.iterator();
	}

	public boolean removeAll(LongCollection arg0) {
		return col.removeAll(arg0);
	}

	public boolean removeElement(long arg0) {
		return col.removeElement(arg0);
	}

	public boolean retainAll(LongCollection arg0) {
		return col.retainAll(arg0);
	}

	public int size() {
		return col.size();
	}

	public long[] toArray() {
		return col.toArray();
	}

	public long[] toArray(long[] arg0) {
		return col.toArray(arg0);
	}

}
