package fi.seco.semweb.util.iterator;

import java.util.Iterator;

public abstract class AMappingIterator<O,E> extends AIterableIterator<E> {

	protected Iterator<? extends O> iter;
	
	public AMappingIterator(IIterableIterator<? extends O> iter) {
		this.iter=iter;
	}
	
	public AMappingIterator(Iterator<? extends O> iter) {
		this.iter=iter;
	}

	public AMappingIterator(Iterable<? extends O> col) {
  	  this(col.iterator());
	}

	@Override
	public boolean hasNext() {
		return iter.hasNext();
	}

	@Override
	public E next() {
		return map(iter.next());
	}

	@Override
	public void remove() {
		iter.remove();
	}
	
	public abstract E map(O src);
		
}
