package fi.seco.semweb.util.iterator;

import fi.seco.semweb.util.sql.NonExceptingResultSet;

public abstract class ANonExceptingResultSetMappingIterator<E> extends AIterableIterator<E> {

	protected NonExceptingResultSet rs;
	boolean hasNextCalled = false;
	
	public ANonExceptingResultSetMappingIterator(NonExceptingResultSet rs) {
		this.rs=rs;
	}

	public abstract E map();

	@Override
	public boolean hasNext() {
		hasNextCalled=true;
		return rs.next();
	}

	@Override
	public E next() {
		if (!hasNextCalled) hasNext();
		hasNextCalled=false;
		return map();
	}

}
