package fi.seco.semweb.util.iterator;

import java.util.Iterator;
import java.util.LinkedList;

public class IteratorIterator<E> extends ALazyGeneratingIterator<E> {

	Iterator<E> iter;
	LinkedList<Iterator<E>> iterStack = new LinkedList<Iterator<E>>();

	public IteratorIterator(Iterator<E> iter) {
		this.iter=iter;
	}

	public IteratorIterator(Iterable<E> col) {
		this.iter=col.iterator();
	}

	public IteratorIterator() {

	}

	public IteratorIterator<E> addIterator(Iterator<E> iter) {
		if (this.iter==null) this.iter=iter;
		else iterStack.add(iter);
		return this;
	}

	public IteratorIterator<E> addIterable(Iterable<E> i) {
		return addIterator(i.iterator());
	}

	@Override
	public void remove() {
		iter.remove();
	}

	@SuppressWarnings("unchecked")
	@Override
	protected E generateNext() {
		if (iter.hasNext()) return iter.next();
		while (!iter.hasNext() && !iterStack.isEmpty()) iter=iterStack.removeFirst();
		if (!iter.hasNext()) return null;
		return iter.next();
	}

}
