package fi.seco.semweb.util.iterator.primitive;

import java.util.Iterator;

import org.apache.commons.collections.primitives.LongIterator;

import fi.seco.semweb.util.iterator.IIterableIterator;

public abstract class AObjectToLongMappingIterator<O> implements LongIterator {

	protected Iterator<? extends O> iter;
	
	public AObjectToLongMappingIterator(IIterableIterator<? extends O> iter) {
		this.iter=iter;
	}
	
	public AObjectToLongMappingIterator(Iterator<? extends O> iter) {
		this.iter=iter;
	}

	public AObjectToLongMappingIterator(Iterable<? extends O> col) {
  	  this(col.iterator());
	}
	public boolean hasNext() {
		return iter.hasNext();
	}

	public long next() {
		return map(iter.next());
	}

	public void remove() {
		iter.remove();
	}
	
	public abstract long map(O o);

}
