package fi.seco.semweb.util.lucene;

import java.io.IOException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.lucene.document.Document;
import org.apache.lucene.search.Hit;
import org.apache.lucene.search.Hits;

import fi.seco.semweb.util.iterator.AMappingIterator;
import fi.seco.semweb.util.iterator.IIterableIterator;

public final class NonExceptingHits implements Iterable<NonExceptingHit> {
	private Hits hits;
	private static Log log = LogFactory.getLog(NonExceptingHits.class);

	public NonExceptingHits(Hits hits) {
		this.hits=hits;
	}

	public final int id(int n) {
		try {
			return hits.id(n);
		} catch (IOException e) {
			log.error("",e);
			return -1;
		}
	}

	public final int length() {
		return hits.length();
	}

	@Override
	public final boolean equals(Object o) {
		return hits.equals(o);
	}

	@Override
	public final int hashCode() {
		return hits.hashCode();
	}

	@SuppressWarnings("unchecked")
	public final IIterableIterator<NonExceptingHit> iterator() {
		return new AMappingIterator<Hit,NonExceptingHit>(hits.iterator()) {

			@Override
			public final NonExceptingHit map(Hit src) {
				return new NonExceptingHit(src);
			}

		};
	}

	public final Document doc(int n) {
		try {
			return hits.doc(n);
		} catch (IOException e) {
			log.error("",e);
			return null;
		}
	}

	@Override
	public final String toString() {
		return hits.toString();
	}

}
