package fi.seco.semweb.util.lucene;

import java.io.IOException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.lucene.search.Explanation;
import org.apache.lucene.search.HitCollector;
import org.apache.lucene.search.Scorer;
import org.apache.lucene.search.Similarity;

public class NonExceptingScorer {
	private Scorer scorer;
	private static Log log = LogFactory.getLog(NonExceptingScorer.class);

	public NonExceptingScorer(Scorer scorer) {
		this.scorer=scorer;
	}

	public int doc() {
		return scorer.doc();
	}

	@Override
	public boolean equals(Object obj) {
		return scorer.equals(obj);
	}

	public Explanation explain(int arg0) {
		try {
			return scorer.explain(arg0);
		} catch (IOException e) {
			log.error("",e);
			return null;
		}
	}

	public Similarity getSimilarity() {
		return scorer.getSimilarity();
	}

	@Override
	public int hashCode() {
		return scorer.hashCode();
	}

	public boolean next() {
		try {
			return scorer.next();
		} catch (IOException e) {
			log.error("",e);
			return false;
		}
	}

	public float score() {
		try {
			return scorer.score();
		} catch (IOException e) {
			log.error("",e);
			return -1.0f;
		}
	}

	public void score(HitCollector arg0) {
		try {
			scorer.score(arg0);
		} catch (IOException e) {
			log.error("",e);
		}
	}

	public boolean skipTo(int arg0) {
		try {
			return scorer.skipTo(arg0);
		} catch (IOException e) {
			log.error("",e);
			return false;
		}
	}

	@Override
	public String toString() {
		return scorer.toString();
	}

}
