package fi.seco.semweb.util.map.primitive;

import java.util.Iterator;

import fi.seco.semweb.util.iterator.IIterableIterator;

public abstract class AIteratorMappingIntObjectHashMap<O1, T2> extends IntObjectHashMap<T2> {
    static final long serialVersionUID = 1L;

	@SuppressWarnings("unchecked")
	public AIteratorMappingIntObjectHashMap(IIterableIterator<? extends O1> iter) {
		this((Iterator<? extends O1>)iter);
	}

	public AIteratorMappingIntObjectHashMap(Iterable<? extends O1> iter) {
		this(iter.iterator());
	}

	public AIteratorMappingIntObjectHashMap(Iterator<? extends O1> iter) {
		for (;iter.hasNext();) {
			O1 o = iter.next();
			int key = map(o);
			super.put(key,getValue(o,key));
		}
	}
	
	public AIteratorMappingIntObjectHashMap(Iterator<? extends O1> iter, int size) {
		ensureCapacity(size);
		for (;iter.hasNext();) {
			O1 o = iter.next();
			int key = map(o);
			super.put(key,getValue(o,key));
		}
	}
	
	protected abstract int map(O1 okey);
	
	protected T2 getValue(O1 okey,int key) {
		return null;
	}
	
}
