package fi.seco.semweb.util.srcgen.templates;

import fi.seco.semweb.util.srcgen.SimplerJastorOntology2JavaConverter;
import java.util.Iterator;
import com.ibm.adtech.jastor.inference.OntologyClass;
import com.ibm.adtech.jastor.inference.OntologyProperty;
import com.ibm.adtech.jastor.jet.OntologyClassFileProvider;
import com.ibm.adtech.jastor.jet.OntologyClassTemplate;

/*******************************************************************************
 * Copyright (c) 2005 IBM Corporation 
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.opensource.org/licenses/cpl.php
 * 
 ******************************************************************************/

public class SimpleImplementationTemplate implements OntologyClassTemplate {
  protected static String nl;
  public static synchronized SimpleImplementationTemplate create(String lineSeparator)
  {
    nl = lineSeparator;
    SimpleImplementationTemplate result = new SimpleImplementationTemplate();
    nl = null;
    return result;
  }

  protected final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = NL + "package ";
  protected final String TEXT_2 = ";" + NL;
  protected final String TEXT_3 = NL + "import com.hp.hpl.jena.rdf.model.Literal;";
  protected final String TEXT_4 = NL + "import com.hp.hpl.jena.rdf.model.Model;" + NL + "import com.hp.hpl.jena.rdf.model.Resource;";
  protected final String TEXT_5 = NL + "import com.hp.hpl.jena.rdf.model.Property;";
  protected final String TEXT_6 = NL + "import com.hp.hpl.jena.rdf.model.Statement;";
  protected final String TEXT_7 = NL + "import com.hp.hpl.jena.vocabulary.RDF;" + NL + "" + NL + "import fi.seco.semweb.util.JenaHelper;";
  protected final String TEXT_8 = NL + "import ";
  protected final String TEXT_9 = ";";
  protected final String TEXT_10 = NL + "import fi.seco.semweb.util.iterator.IIterableIterator;" + NL + "import fi.seco.semweb.util.iterator.AStatementMappingIterator;";
  protected final String TEXT_11 = NL + NL + "public class ";
  protected final String TEXT_12 = " extends ";
  protected final String TEXT_13 = "/*";
  protected final String TEXT_14 = ", ";
  protected final String TEXT_15 = "*/";
  protected final String TEXT_16 = " {" + NL + "" + NL + "\tprivate static final long serialVersionUID = 1L;" + NL + "\tpublic static final Resource TYPE = JenaHelper.r(\"";
  protected final String TEXT_17 = "\");" + NL + "\t" + NL + "   \tpublic ";
  protected final String TEXT_18 = "(Resource resource) {" + NL + "   \t  \tsuper(resource);" + NL + "   \t}" + NL + "" + NL + "   \tpublic ";
  protected final String TEXT_19 = "(Model m, String uri) {" + NL + "   \t  \tsuper(JenaHelper.r(m,uri));" + NL + "   \t}" + NL + "   \t" + NL + "\tpublic static ";
  protected final String TEXT_20 = " create(Model m) {" + NL + "\t\treturn create(JenaHelper.r(m));" + NL + "\t}" + NL + "" + NL + "\tpublic static ";
  protected final String TEXT_21 = " create(Model m, String resourceURI) {" + NL + "\t\treturn create(JenaHelper.r(m,resourceURI));" + NL + "\t}" + NL + "   \t\t" + NL + "\tpublic static ";
  protected final String TEXT_22 = " create(Resource resource) {" + NL + "\t\tresource.addProperty(RDF.type,TYPE);" + NL + "\t\treturn new ";
  protected final String TEXT_23 = "(resource);" + NL + "\t}" + NL + "\t";
  protected final String TEXT_24 = NL + NL + "\tpublic ";
  protected final String TEXT_25 = " get";
  protected final String TEXT_26 = "() {";
  protected final String TEXT_27 = "\t   " + NL + "\t   \treturn getProperty(";
  protected final String TEXT_28 = "Property).getLiteral();";
  protected final String TEXT_29 = NL + "        return getProperty(";
  protected final String TEXT_30 = "Property).getBoolean();";
  protected final String TEXT_31 = NL + "        return getProperty(";
  protected final String TEXT_32 = "Property).getByte();";
  protected final String TEXT_33 = NL + "        return getProperty(";
  protected final String TEXT_34 = "Property).getChar();";
  protected final String TEXT_35 = NL + "        return getProperty(";
  protected final String TEXT_36 = "Property).getDouble();";
  protected final String TEXT_37 = NL + "        return getProperty(";
  protected final String TEXT_38 = "Property).getFloat();";
  protected final String TEXT_39 = NL + "        return getProperty(";
  protected final String TEXT_40 = "Property).getInt();";
  protected final String TEXT_41 = NL + "        return getProperty(";
  protected final String TEXT_42 = "Property).getLong();";
  protected final String TEXT_43 = NL + "        return getProperty(";
  protected final String TEXT_44 = "Property).getShort();";
  protected final String TEXT_45 = NL + "        return getProperty(";
  protected final String TEXT_46 = "Property).getString();";
  protected final String TEXT_47 = NL + "\t}" + NL + "" + NL + "\tpublic void set";
  protected final String TEXT_48 = "(";
  protected final String TEXT_49 = " ";
  protected final String TEXT_50 = ") {" + NL + "\t\tmodel.removeAll(resource,";
  protected final String TEXT_51 = "Property,null);" + NL + "\t\tresource.addProperty(";
  protected final String TEXT_52 = "Property,";
  protected final String TEXT_53 = ");\t\t" + NL + "\t}";
  protected final String TEXT_54 = NL + NL + "\tpublic IIterableIterator<";
  protected final String TEXT_55 = "> get";
  protected final String TEXT_56 = "() {" + NL + "\t   return new AStatementMappingIterator<";
  protected final String TEXT_57 = ">(listProperties(";
  protected final String TEXT_58 = "Property)) { public ";
  protected final String TEXT_59 = " map(Statement s) {";
  protected final String TEXT_60 = "\t   " + NL + "\t   \t\treturn s.getLiteral();";
  protected final String TEXT_61 = NL + "        \treturn s.getBoolean();";
  protected final String TEXT_62 = NL + "        \treturn s.getByte();";
  protected final String TEXT_63 = NL + "        \treturn s.getChar();";
  protected final String TEXT_64 = NL + "        \treturn s.getDouble();";
  protected final String TEXT_65 = NL + "        \treturn s.getFloat();";
  protected final String TEXT_66 = NL + "        \treturn s.getInt();";
  protected final String TEXT_67 = NL + "        \treturn s.getLong();";
  protected final String TEXT_68 = NL + "        \treturn s.getShort();";
  protected final String TEXT_69 = NL + "        \treturn s.getString();";
  protected final String TEXT_70 = NL + "\t   }};" + NL + "\t   " + NL + "\t}" + NL + "" + NL + "\tpublic void add";
  protected final String TEXT_71 = "(";
  protected final String TEXT_72 = " ";
  protected final String TEXT_73 = ") {" + NL + "\t   resource.addProperty(";
  protected final String TEXT_74 = "Property,";
  protected final String TEXT_75 = ");" + NL + "\t}" + NL + "\t" + NL + "\tpublic void remove";
  protected final String TEXT_76 = "(";
  protected final String TEXT_77 = " ";
  protected final String TEXT_78 = ") {" + NL + "\t   model.removeAll(resource,";
  protected final String TEXT_79 = "Property,model.createTypedLiteral(";
  protected final String TEXT_80 = "));" + NL + "\t}" + NL;
  protected final String TEXT_81 = NL + "\tpublic ";
  protected final String TEXT_82 = " get";
  protected final String TEXT_83 = "() {" + NL + "\t\treturn new ";
  protected final String TEXT_84 = "(resource.getProperty(";
  protected final String TEXT_85 = "Property).getResource());" + NL + "\t}" + NL + "" + NL + "\tpublic void set";
  protected final String TEXT_86 = "(";
  protected final String TEXT_87 = " ";
  protected final String TEXT_88 = ") {" + NL + "\t\tmodel.removeAll(resource,";
  protected final String TEXT_89 = "Property,null);" + NL + "\t\tresource.addProperty(";
  protected final String TEXT_90 = "Property,";
  protected final String TEXT_91 = ");\t\t" + NL + "\t}" + NL + "\t";
  protected final String TEXT_92 = NL + "\tpublic IIterableIterator<";
  protected final String TEXT_93 = "> get";
  protected final String TEXT_94 = "() {" + NL + "\t   return new AStatementMappingIterator<";
  protected final String TEXT_95 = ">(listProperties(";
  protected final String TEXT_96 = "Property)) {" + NL + "\t   \t\tpublic ";
  protected final String TEXT_97 = " map(Statement s) {" + NL + "\t   \t\t\treturn new ";
  protected final String TEXT_98 = "(s.getResource());" + NL + "\t   \t\t}};" + NL + "\t}" + NL + "" + NL + "\tpublic void add";
  protected final String TEXT_99 = "(";
  protected final String TEXT_100 = " ";
  protected final String TEXT_101 = ") {" + NL + "\t\tresource.addProperty(";
  protected final String TEXT_102 = "Property,";
  protected final String TEXT_103 = ".getResource());" + NL + "\t}" + NL + "\t" + NL + "\tpublic void remove";
  protected final String TEXT_104 = "(";
  protected final String TEXT_105 = " ";
  protected final String TEXT_106 = ") {" + NL + "\t    model.removeAll(resource,";
  protected final String TEXT_107 = "Property,";
  protected final String TEXT_108 = ".getResource());" + NL + "\t}" + NL + "\t\t";
  protected final String TEXT_109 = NL + "\tpublic static final Property ";
  protected final String TEXT_110 = "Property = JenaHelper.p(\"";
  protected final String TEXT_111 = "\");";
  protected final String TEXT_112 = NL + NL + NL + "}";

	public static final String copyright = "(C) Copyright IBM Corporation 2005  All Rights Reserved.";
	
	OntologyClassFileProvider fileProvider;

	public SimpleImplementationTemplate(OntologyClassFileProvider fileProvider) {
		this.fileProvider = fileProvider;
	}
	
	public SimpleImplementationTemplate() {
	}
	
	public OntologyClassFileProvider getFileProvider() {
		return fileProvider;
	}	
	
	public void setFileProvider(OntologyClassFileProvider fileProvider) {
		this.fileProvider = fileProvider;
	}

	public String generate(OntologyClass oc)
  {
    final StringBuffer stringBuffer = new StringBuffer();
    stringBuffer.append(TEXT_1);
    stringBuffer.append(oc.getPackageName());
    stringBuffer.append(TEXT_2);
     boolean importLiteral=false;
   boolean hasMultiValues=false;
   Iterator iter = oc.listProperties(false).iterator();
   for (; iter.hasNext();) {
 		OntologyProperty prop = (OntologyProperty)iter.next(); 
  		if (prop.getReturnType().equals("com.hp.hpl.jena.rdf.model.Literal")) importLiteral=true;
  		else if (prop.isMultiValued()) hasMultiValues=true;
   }
   if (importLiteral) {
    stringBuffer.append(TEXT_3);
     } 
    stringBuffer.append(TEXT_4);
       iter = oc.listProperties(false).iterator();
   if (iter.hasNext()) { 
    stringBuffer.append(TEXT_5);
     }
   if (hasMultiValues) {
    stringBuffer.append(TEXT_6);
     }

    stringBuffer.append(TEXT_7);
    
   iter = oc.listImmediateExtensionClasses().iterator(); 
if (!iter.hasNext()) { 
    stringBuffer.append(TEXT_8);
    stringBuffer.append(oc.getContext().getThingImpl().getName());
    stringBuffer.append(TEXT_9);
     } if (hasMultiValues) { 
    stringBuffer.append(TEXT_10);
     } 
    stringBuffer.append(TEXT_11);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_12);
     iter = oc.listImmediateExtensionClasses().iterator(); 
   if (iter.hasNext()) { 
   		OntologyClass extClass = (OntologyClass)iter.next();
    stringBuffer.append(extClass.getInterfaceClassname());
    
   		if (iter.hasNext()) {
		    
    stringBuffer.append(TEXT_13);
    
    		System.out.println("Warning: "+oc.getInterfaceFullClassname()+ " multiple inherits from:");
    		System.out.println(" * "+extClass.getInterfaceFullClassname());
    		for (;iter.hasNext();) {
    			OntologyClass tmp = (OntologyClass)iter.next();
    			
    stringBuffer.append(TEXT_14);
    stringBuffer.append(tmp.getInterfaceClassname());
     
    			System.out.println(" * "+tmp.getInterfaceFullClassname());
    		}
    		System.out.println("Only the first one has been taken into account in the Java inheritance hierarchy");
    		
    stringBuffer.append(TEXT_15);
    
   		}
   } else { 
	   String[] tmp = oc.getContext().getThingImpl().getName().split("\\.");
   
    stringBuffer.append(tmp[tmp.length-1]);
     } 
    stringBuffer.append(TEXT_16);
    stringBuffer.append(oc.getURI());
    stringBuffer.append(TEXT_17);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_18);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_19);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_20);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_21);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_22);
    stringBuffer.append(oc.getInterfaceClassname());
    stringBuffer.append(TEXT_23);
     	for (iter = oc.listProperties(false).iterator(); iter.hasNext();) {
     		OntologyProperty prop = (OntologyProperty)iter.next(); 
    			if (prop.isSingleValued() && prop.isDatatypeProperty()) { 
    stringBuffer.append(TEXT_24);
    stringBuffer.append(SimplerJastorOntology2JavaConverter.getTypeForClass(prop.getReturnType()));
    stringBuffer.append(TEXT_25);
    stringBuffer.append(prop.getPropertyCapped());
    stringBuffer.append(TEXT_26);
     	   if (prop.getReturnType().equals("com.hp.hpl.jena.rdf.model.Literal")) { 
    stringBuffer.append(TEXT_27);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_28);
         } else if (prop.getReturnType().equals("java.lang.Boolean")) { 
    stringBuffer.append(TEXT_29);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_30);
         } else if (prop.getReturnType().equals("java.lang.Byte")) { 
    stringBuffer.append(TEXT_31);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_32);
         } else if (prop.getReturnType().equals("java.lang.Character")) { 
    stringBuffer.append(TEXT_33);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_34);
         } else if (prop.getReturnType().equals("java.lang.Double")) { 
    stringBuffer.append(TEXT_35);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_36);
         } else if (prop.getReturnType().equals("java.lang.Float")) { 
    stringBuffer.append(TEXT_37);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_38);
         } else if (prop.getReturnType().equals("java.lang.Integer")) { 
    stringBuffer.append(TEXT_39);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_40);
         } else if (prop.getReturnType().equals("java.lang.Long")) { 
    stringBuffer.append(TEXT_41);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_42);
         } else if (prop.getReturnType().equals("java.lang.Short")) { 
    stringBuffer.append(TEXT_43);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_44);
         } else if (prop.getReturnType().equals("java.lang.String")) { 
    stringBuffer.append(TEXT_45);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_46);
         } 
    stringBuffer.append(TEXT_47);
    stringBuffer.append(prop.getPropertyCapped());
    stringBuffer.append(TEXT_48);
    stringBuffer.append(SimplerJastorOntology2JavaConverter.getTypeForClass(prop.getReturnType()));
    stringBuffer.append(TEXT_49);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_50);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_51);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_52);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_53);
           } 
    			if (prop.isMultiValued() && prop.isDatatypeProperty()) { 
    stringBuffer.append(TEXT_54);
    stringBuffer.append(SimplerJastorOntology2JavaConverter.shortName(prop.getReturnType()));
    stringBuffer.append(TEXT_55);
    stringBuffer.append(prop.getPropertyCapped());
    stringBuffer.append(TEXT_56);
    stringBuffer.append(SimplerJastorOntology2JavaConverter.shortName(prop.getReturnType()));
    stringBuffer.append(TEXT_57);
    stringBuffer.append( prop.getPropertyName() );
    stringBuffer.append(TEXT_58);
    stringBuffer.append(SimplerJastorOntology2JavaConverter.shortName(prop.getReturnType()));
    stringBuffer.append(TEXT_59);
     	   if (prop.getReturnType().equals("com.hp.hpl.jena.rdf.model.Literal")) { 
    stringBuffer.append(TEXT_60);
         } else if (prop.getReturnType().equals("java.lang.Boolean")) { 
    stringBuffer.append(TEXT_61);
         } else if (prop.getReturnType().equals("java.lang.Byte")) { 
    stringBuffer.append(TEXT_62);
         } else if (prop.getReturnType().equals("java.lang.Character")) { 
    stringBuffer.append(TEXT_63);
         } else if (prop.getReturnType().equals("java.lang.Double")) { 
    stringBuffer.append(TEXT_64);
         } else if (prop.getReturnType().equals("java.lang.Float")) { 
    stringBuffer.append(TEXT_65);
         } else if (prop.getReturnType().equals("java.lang.Integer")) { 
    stringBuffer.append(TEXT_66);
         } else if (prop.getReturnType().equals("java.lang.Long")) { 
    stringBuffer.append(TEXT_67);
         } else if (prop.getReturnType().equals("java.lang.Short")) { 
    stringBuffer.append(TEXT_68);
         } else if (prop.getReturnType().equals("java.lang.String")) { 
    stringBuffer.append(TEXT_69);
         } 
    stringBuffer.append(TEXT_70);
    stringBuffer.append(prop.getPropertyCapped());
    stringBuffer.append(TEXT_71);
    stringBuffer.append(SimplerJastorOntology2JavaConverter.getTypeForClass(prop.getReturnType()));
    stringBuffer.append(TEXT_72);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_73);
    stringBuffer.append( prop.getPropertyName() );
    stringBuffer.append(TEXT_74);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_75);
    stringBuffer.append(prop.getPropertyCapped());
    stringBuffer.append(TEXT_76);
    stringBuffer.append(SimplerJastorOntology2JavaConverter.getTypeForClass(prop.getReturnType()));
    stringBuffer.append(TEXT_77);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_78);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_79);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_80);
           } 
    			if (prop.isSingleValued() && prop.isObjectProperty()) { 
    stringBuffer.append(TEXT_81);
    stringBuffer.append(SimplerJastorOntology2JavaConverter.shortName(prop.getReturnType()));
    stringBuffer.append(TEXT_82);
    stringBuffer.append(prop.getPropertyCapped());
    stringBuffer.append(TEXT_83);
    stringBuffer.append(prop.getReturnType() );
    stringBuffer.append(TEXT_84);
    stringBuffer.append( prop.getPropertyName() );
    stringBuffer.append(TEXT_85);
    stringBuffer.append(prop.getPropertyCapped());
    stringBuffer.append(TEXT_86);
    stringBuffer.append(SimplerJastorOntology2JavaConverter.shortName(prop.getReturnType()));
    stringBuffer.append(TEXT_87);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_88);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_89);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_90);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_91);
              } 
    			if (prop.isMultiValued() && prop.isObjectProperty()) { 
    stringBuffer.append(TEXT_92);
    stringBuffer.append(SimplerJastorOntology2JavaConverter.shortName(prop.getReturnType()));
    stringBuffer.append(TEXT_93);
    stringBuffer.append(prop.getPropertyCapped());
    stringBuffer.append(TEXT_94);
    stringBuffer.append(SimplerJastorOntology2JavaConverter.shortName(prop.getReturnType()) );
    stringBuffer.append(TEXT_95);
    stringBuffer.append( prop.getPropertyName() );
    stringBuffer.append(TEXT_96);
    stringBuffer.append(SimplerJastorOntology2JavaConverter.shortName(prop.getReturnType()) );
    stringBuffer.append(TEXT_97);
    stringBuffer.append(SimplerJastorOntology2JavaConverter.shortName(prop.getReturnType()) );
    stringBuffer.append(TEXT_98);
    stringBuffer.append(prop.getPropertyCapped());
    stringBuffer.append(TEXT_99);
    stringBuffer.append(SimplerJastorOntology2JavaConverter.shortName(prop.getReturnType()));
    stringBuffer.append(TEXT_100);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_101);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_102);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_103);
    stringBuffer.append(prop.getPropertyCapped());
    stringBuffer.append(TEXT_104);
    stringBuffer.append(SimplerJastorOntology2JavaConverter.shortName(prop.getReturnType()));
    stringBuffer.append(TEXT_105);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_106);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_107);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_108);
              } 
           } 
     for (iter = oc.listProperties(false).iterator(); iter.hasNext();) {
     OntologyProperty prop = (OntologyProperty)iter.next(); 
    stringBuffer.append(TEXT_109);
    stringBuffer.append(prop.getPropertyName());
    stringBuffer.append(TEXT_110);
    stringBuffer.append(prop.getURI());
    stringBuffer.append(TEXT_111);
     } 
    stringBuffer.append(TEXT_112);
    return stringBuffer.toString();
  }
}