package fi.seco.semweb.view.js.widget.tree;

import java.util.Collection;
import java.util.Map;

import fi.seco.semweb.service.indexing.tree.ITreeIndexProvider;
import fi.seco.semweb.service.indexing.tree.model.SearchableCategoryInfo;
import fi.seco.semweb.service.search.ItemSearchController;
import fi.seco.semweb.util.dwr.JSIHelper;
import fi.seco.semweb.view.js.vbsearch.JSSearchController;
import fi.seco.semweb.view.js.widget.tree.model.JSMatchResponse;
import fi.seco.semweb.view.js.widget.tree.model.SearchableJSINode;

public class SearchableTreeViewJSI {

	private ITreeIndexProvider<SearchableCategoryInfo> icontroller;
	private ItemSearchController scontroller;

	public void setIndexingController(ITreeIndexProvider<SearchableCategoryInfo> icontroller) {
		this.icontroller=icontroller;
	}

	public void setSearchController(ItemSearchController scontroller) {
		this.scontroller=scontroller;
	}

	public void create(String widgetId, String treeId) {
		JSSearchController ksc = JSIHelper.getSessionObjectThatMayNotExist("searchController");
		if (ksc==null) {
			ksc = new JSSearchController(scontroller);
			JSIHelper.putSessionObject("searchController", ksc);
		}
		JSSearchableTreeView widget = new JSSearchableTreeView(icontroller.getTree(treeId),ksc,widgetId);
		JSIHelper.putSessionObject(widgetId, widget);
	}

	public Collection<SearchableJSINode> getChildren(final String widgetId,int nodeId, final String prefLang) {
		JSSearchableTreeView view = JSIHelper.getSessionObject(widgetId);
		if (view==null) return null;
		return view.getChildren(nodeId,prefLang);
	}

	public JSMatchResponse match(final String widgetId, final String text, final String prefLang) {
		JSSearchableTreeView view = JSIHelper.getSessionObject(widgetId);
		if (view==null) return null;
		return view.match(text,prefLang);
	}

	public Map<String,Object> deselect(String widgetId, int nodeId) {
		JSSearchableTreeView view = JSIHelper.getSessionObject(widgetId);
		if (view==null) return null;
		if (view.deselect(nodeId)) return ((JSSearchController) JSIHelper.getSessionObject("searchController")).getViewUpdates();
		return null;
	}

	public Map<String,Object> select(String widgetId, int nodeId) {
		JSSearchableTreeView view = JSIHelper.getSessionObject(widgetId);
		if (view==null) return null;
		if (view.select(nodeId)) return ((JSSearchController) JSIHelper.getSessionObject("searchController")).getViewUpdates();
		return null;
	}

}