package fi.seco.semweb.view.js.widget.tree;

import java.util.Collection;
import java.util.Map;

import fi.seco.semweb.service.indexing.tree.TreeIndexService;
import fi.seco.semweb.service.indexing.tree.model.IndexedNode;
import fi.seco.semweb.util.collection.AMappingCollection;
import fi.seco.semweb.util.dwr.JSIHelper;
import fi.seco.semweb.view.js.widget.tree.model.JSINode;

public class TreeViewJSI<T> {

	private Map<String,TreeIndexService<T>> treeMap;

	public void setTreeMap(Map<String,TreeIndexService<T>> treeMap) {
		this.treeMap=treeMap;
	}

	public void create(String widgetId, String viewId) {
		TreeView<T> widget = new TreeView<T>(treeMap.get(viewId));
		JSIHelper.putSessionObject(widgetId, widget);
	}

	public Collection<JSINode<T>> getChildren(final String widgetId,int nodeId) {
		TreeView<T> view = JSIHelper.getSessionObject(widgetId);
		return new AMappingCollection<IndexedNode<T>, JSINode<T>>(view.getChildren(nodeId)) {
			@Override public JSINode<T> map(IndexedNode<T> a) {
				return new JSINode<T>(a,widgetId,a.getId());
			}
		};
	}

}
